VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7980
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   9345
   LinkTopic       =   "Form1"
   ScaleHeight     =   7980
   ScaleWidth      =   9345
   StartUpPosition =   3  'Windows-Standard
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      LargeChange     =   5
      Left            =   7800
      Max             =   100
      TabIndex        =   1
      Top             =   540
      Value           =   90
      Width           =   1275
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  '2D
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      DrawWidth       =   5
      ForeColor       =   &H80000008&
      Height          =   7485
      Left            =   240
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   497
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   497
      TabIndex        =   0
      Top             =   240
      Width           =   7485
   End
   Begin VB.Label Label1 
      Caption         =   "Radius: 90%"
      Height          =   195
      Left            =   7800
      TabIndex        =   2
      Top             =   240
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetPixel Lib "gdi32.dll" (ByVal hdc As Long, ByVal nXPos As Long, ByVal nYPos As Long) As Long

Private Const PI As Single = 3.1415926

Private Center As POINTAPI
Private PixelMap() As Long

Private Function GetPixelMap()

Dim i As Long
Dim j As Long
Dim OldCap As String
Dim APIRed As Byte
Dim APIGreen As Byte
Dim APIBlue As Byte
Dim TempCol As Long

ReDim PixelMap(0 To Form1.Picture1.ScaleWidth - 1, 0 To Form1.Picture1.ScaleHeight - 1)

Form1.MousePointer = vbHourglass
OldCap = Form1.Caption
Form1.Caption = "Warming pixel map. Be patient..."

For i = 0 To Form1.Picture1.ScaleWidth - 1
    For j = 0 To Form1.Picture1.ScaleHeight - 1
        TempCol = GetPixel(Form1.Picture1.hdc, i, j)
        
        APIRed = (TempCol And &HFF&)
        APIGreen = (TempCol And &HFF00&) \ &H100
        APIBlue = (TempCol And &HFF0000) \ &H10000
        
        PixelMap(i, j) = RGB(APIBlue, APIGreen, APIRed)
    Next
Next

Form1.MousePointer = vbDefault
Form1.Caption = OldCap

End Function

Private Function GetAngle(Center As POINTAPI, Rotated As POINTAPI) As Single

Dim Numerator As Single
Dim Denominator As Single
Dim Radiant As Single

Numerator = Rotated.Y - Center.Y
Denominator = Rotated.X - Center.X

If Denominator = 0 Then
    If Numerator < 0 Then Radiant = 0.5 * PI
    If Numerator > 0 Then Radiant = 1.5 * PI
    If Numerator = 0 Then Radiant = 0
    
    GetAngle = Radiant
    Exit Function
End If

Radiant = Atn(Numerator / Denominator)

If Numerator <= 0 And Denominator >= 0 Then 'Quadrant I
    Radiant = Abs(Radiant)

    GetAngle = Radiant
    Exit Function
End If
If Numerator <= 0 And Denominator <= 0 Then 'Quadrant II
    Radiant = PI - Radiant
    
    GetAngle = Radiant
    Exit Function
End If
If Numerator >= 0 And Denominator <= 0 Then 'Quadrant III
    Radiant = PI + Abs(Radiant)

    GetAngle = Radiant
    Exit Function
End If
If Numerator >= 0 And Denominator >= 0 Then 'Quadrant IV
    Radiant = (2 * PI) - Radiant

    GetAngle = Radiant
    Exit Function
End If

GetAngle = Radiant

End Function

Private Function RotatePointAroundCenter(Center As POINTAPI, Point As POINTAPI, Angle As Single, Dist As Single) As POINTAPI

Dim TempPoint1 As POINTAPI
Dim TempPoint2 As POINTAPI

TempPoint1.X = Center.X + Dist
TempPoint1.Y = Center.Y
TempPoint2.X = Center.X + (Cos(Angle) * (TempPoint1.X - Center.X))
TempPoint2.Y = Center.Y - (Sin(Angle) * (TempPoint1.X - Center.X))

RotatePointAroundCenter = TempPoint2

End Function

Private Sub Tunnel(Optional RadiusPercentage As Single = 0.9)

Dim InnerStartPoint As POINTAPI
Dim OuterStartPoint As POINTAPI
Dim InnerPoint As POINTAPI
Dim OuterPoint As POINTAPI
Dim i As Single
Dim InnerDist As Single
Dim OuterDist As Single

Form1.Picture1.Cls
Call UpdateGDIpObject
Call SetAA

Form1.MousePointer = vbArrowHourglass

InnerStartPoint.X = Center.X + (RadiusPercentage * Center.X)
InnerStartPoint.Y = Center.Y
InnerDist = Sqr(((Center.X - InnerStartPoint.X) ^ 2) + ((Center.Y - InnerStartPoint.Y) ^ 2))

OuterStartPoint.X = (Form1.Picture1.ScaleWidth \ 2) + (Sqr((Form1.Picture1.ScaleWidth ^ 2) + (Form1.Picture1.ScaleHeight ^ 2)) / 2)
OuterStartPoint.Y = Center.Y
OuterDist = Sqr(((Center.X - OuterStartPoint.X) ^ 2) + ((Center.Y - OuterStartPoint.Y) ^ 2))

For i = 0 To 2 * PI Step 0.01
    InnerPoint = RotatePointAroundCenter(Center, InnerStartPoint, i, InnerDist)
    OuterPoint = RotatePointAroundCenter(Center, OuterStartPoint, i, OuterDist)

    Call Draw(InnerPoint, OuterPoint, PixelMap(InnerPoint.X, InnerPoint.Y))
Next

Form1.MousePointer = vbDefault

End Sub

Private Sub Form_Load()

Center.X = Form1.Picture1.ScaleWidth / 2
Center.Y = Form1.Picture1.ScaleHeight / 2

Call StartGDIp

Form1.Show

DoEvents

Call GetPixelMap

Call Tunnel(Form1.HScroll1 / 100)

End Sub

Private Sub Form_Unload(Cancel As Integer)

Call CloseGDIp

End Sub

Private Sub HScroll1_Change()

Form1.Label1 = "Radius: " & Form1.HScroll1.Value & "%"
Call Tunnel(Form1.HScroll1 / 100)

End Sub
