Attribute VB_Name = "Module1"
Option Explicit

Public Type POINTAPI
    X As Long
    Y As Long
End Type

' GDI+ constants:
Private Const QualityModeInvalid As Long = -1&
Private Const QualityModeDefault As Long = 0&
Private Const QualityModeLow As Long = 1&
Private Const QualityModeHigh As Long = 2&

' GDI+ types:
Private Type GdiplusStartupInput
    GdiplusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

' Global:
Private Declare Function GdiplusStartup Lib "gdiplus.dll" (ByRef token As Long, ByRef inputX As GdiplusStartupInput, ByVal Output As Long) As Status
Private Declare Sub GdiplusShutdown Lib "gdiplus.dll" (ByVal token As Long)

' Graphics:
Private Declare Function GdipCreateFromHDC Lib "gdiplus.dll" (ByVal hdc As Long, ByRef graphics As Long) As Status
Private Declare Function GdipDeleteGraphics Lib "gdiplus.dll" (ByVal graphics As Long) As Status
Private Declare Function GdipSetSmoothingMode Lib "gdiplus.dll" (ByVal graphics As Long, ByVal SmoothingMode As SmoothingMode) As Status

' Pens:
Private Declare Function GdipCreatePen1 Lib "gdiplus.dll" (ByVal Color As Long, ByVal Width As Single, ByVal Unit As Unit, ByRef pen As Long) As Status
Private Declare Function GdipDeletePen Lib "gdiplus.dll" (ByVal pen As Long) As Status
Private Declare Function GdipDrawLineI Lib "gdiplus.dll" (ByVal graphics As Long, ByVal pen As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Status

' GDI+ enums:
Private Enum Status
    OK = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
    ProfileNotFound = 21
End Enum

Private Enum Unit
    UnitWorld = 0
    UnitDisplay = 1
    UnitPixel = 2
    UnitPoint = 3
    UnitInch = 4
    UnitDocument = 5
    UnitMillimeter = 6
End Enum

Private Enum SmoothingMode
    SmoothingModeInvalid = QualityModeInvalid
    SmoothingModeDefault = QualityModeDefault
    SmoothingModeHighSpeed = QualityModeLow
    SmoothingModeHighQuality = QualityModeHigh
    SmoothingModeNone = QualityModeHigh + 1
    SmoothingModeAntiAlias8x4 = QualityModeHigh + 2
    SmoothingModeAntiAlias = SmoothingModeAntiAlias8x4
    SmoothingModeAntiAlias8x8 = QualityModeHigh + 3
End Enum

Private MyPen As Long

Private mInstance As Long
Private mGraphics As Long

Public Sub StartGDIp()

Dim Data As GdiplusStartupInput

Data.GdiplusVersion = 1

If GdiplusStartup(mInstance, Data, 0) Then
    MsgBox "GDI+ could not be initialized.", vbCritical
    Exit Sub
End If

End Sub

Public Sub CloseGDIp()

Dim MyStatus As Status
MyStatus = GdipDeletePen(MyPen)

If mGraphics Then If GdipDeleteGraphics(mGraphics) Then MsgBox "Graphics object could not be deleted.", vbCritical
Call GdiplusShutdown(mInstance)

End Sub

Public Sub UpdateGDIpObject()

If GdipCreateFromHDC(Form1.Picture1.hdc, mGraphics) Then
    MsgBox "Graphics object could not be created.", vbCritical
    Exit Sub
End If

End Sub

Public Function SetAA() As Boolean

If GdipSetSmoothingMode(mGraphics, QualityModeHigh) Then
    MsgBox "Antialiasing mode could not be initialized.", vbCritical
    Exit Function
End If

SetAA = True

End Function

Public Sub Draw(P1 As POINTAPI, P2 As POINTAPI, MyCol As Long)

Dim MyStatus As Status

MyStatus = GdipCreatePen1(&HFF000000 Or MyCol, 5, UnitPixel, MyPen)
MyStatus = GdipDrawLineI(mGraphics, MyPen, P1.X, P1.Y, P2.X, P2.Y)
MyStatus = GdipDeletePen(MyPen)

End Sub















